
#include "arb_vertex_program.h"
#include <stdlib.h>


//variable indiquant si l'extensions GL_ARB_vertex_program est dfinit.
//initialis  false par dfaut.
bool ARB_Vertex_Program_IsDefined = false;



PFNGLVERTEXATTRIB1SARBPROC glVertexAttrib1sARB;
PFNGLVERTEXATTRIB1FARBPROC glVertexAttrib1fARB;
PFNGLVERTEXATTRIB1DARBPROC glVertexAttrib1dARB;
PFNGLVERTEXATTRIB2SARBPROC glVertexAttrib2sARB;
PFNGLVERTEXATTRIB2FARBPROC glVertexAttrib2fARB;
PFNGLVERTEXATTRIB2DARBPROC glVertexAttrib2dARB;
PFNGLVERTEXATTRIB3SARBPROC glVertexAttrib3sARB;
PFNGLVERTEXATTRIB3FARBPROC glVertexAttrib3fARB;
PFNGLVERTEXATTRIB3DARBPROC glVertexAttrib3dARB;
PFNGLVERTEXATTRIB4SARBPROC glVertexAttrib4sARB;
PFNGLVERTEXATTRIB4FARBPROC glVertexAttrib4fARB;
PFNGLVERTEXATTRIB4DARBPROC glVertexAttrib4dARB;
PFNGLVERTEXATTRIB4NUBARBPROC glVertexAttrib4NubARB;
PFNGLVERTEXATTRIB1SVARBPROC glVertexAttrib1svARB;
PFNGLVERTEXATTRIB1FVARBPROC glVertexAttrib1fvARB;
PFNGLVERTEXATTRIB1DVARBPROC glVertexAttrib1dvARB;
PFNGLVERTEXATTRIB2SVARBPROC glVertexAttrib2svARB;
PFNGLVERTEXATTRIB2FVARBPROC glVertexAttrib2fvARB;
PFNGLVERTEXATTRIB2DVARBPROC glVertexAttrib2dvARB;
PFNGLVERTEXATTRIB3SVARBPROC glVertexAttrib3svARB;
PFNGLVERTEXATTRIB3FVARBPROC glVertexAttrib3fvARB;
PFNGLVERTEXATTRIB3DVARBPROC glVertexAttrib3dvARB;
PFNGLVERTEXATTRIB4BVARBPROC glVertexAttrib4bvARB;
PFNGLVERTEXATTRIB4SVARBPROC glVertexAttrib4svARB;
PFNGLVERTEXATTRIB4IVARBPROC glVertexAttrib4ivARB;
PFNGLVERTEXATTRIB4UBVARBPROC glVertexAttrib4ubvARB;
PFNGLVERTEXATTRIB4USVARBPROC glVertexAttrib4usvARB;
PFNGLVERTEXATTRIB4UIVARBPROC glVertexAttrib4uivARB;
PFNGLVERTEXATTRIB4FVARBPROC glVertexAttrib4fvARB;
PFNGLVERTEXATTRIB4DVARBPROC glVertexAttrib4dvARB;
PFNGLVERTEXATTRIB4NBVARBPROC glVertexAttrib4NbvARB;
PFNGLVERTEXATTRIB4NSVARBPROC glVertexAttrib4NsvARB;
PFNGLVERTEXATTRIB4NIVARBPROC glVertexAttrib4NivARB;
PFNGLVERTEXATTRIB4NUBVARBPROC glVertexAttrib4NubvARB;
PFNGLVERTEXATTRIB4NUSVARBPROC glVertexAttrib4NusvARB;
PFNGLVERTEXATTRIB4NUIVARBPROC glVertexAttrib4NuivARB;

PFNGLVERTEXATTRIBPOINTERARBPROC glVertexAttribPointerARB;
PFNGLENABLEVERTEXATTRIBARRAYARBPROC glEnableVertexAttribArrayARB;
PFNGLDISABLEVERTEXATTRIBARRAYARBPROC glDisableVertexAttribArrayARB;
PFNGLPROGRAMSTRINGARBPROC glProgramStringARB;
PFNGLBINDPROGRAMARBPROC glBindProgramARB;
PFNGLDELETEPROGRAMSARBPROC glDeleteProgramsARB;
PFNGLGENPROGRAMSARBPROC glGenProgramsARB;

PFNGLPROGRAMENVPARAMETER4DARBPROC glProgramEnvParameter4dARB;
PFNGLPROGRAMENVPARAMETER4DVARBPROC glProgramEnvParameter4dvARB;
PFNGLPROGRAMENVPARAMETER4FARBPROC glProgramEnvParameter4fARB;
PFNGLPROGRAMENVPARAMETER4FVARBPROC glProgramEnvParameter4fvARB;

PFNGLPROGRAMLOCALPARAMETER4DARBPROC glProgramLocalParameter4dARB;
PFNGLPROGRAMLOCALPARAMETER4DVARBPROC glProgramLocalParameter4dvARB;
PFNGLPROGRAMLOCALPARAMETER4FARBPROC glProgramLocalParameter4fARB;
PFNGLPROGRAMLOCALPARAMETER4FVARBPROC glProgramLocalParameter4fvARB;

PFNGLGETPROGRAMENVPARAMETERDVARBPROC glGetProgramEnvParameterdvARB;
PFNGLGETPROGRAMENVPARAMETERFVARBPROC glGetProgramEnvParameterfvARB;
PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC glGetProgramLocalParameterdvARB;
PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC glGetProgramLocalParameterfvARB;
PFNGLGETPROGRAMIVARBPROC glGetProgramivARB;
PFNGLGETPROGRAMSTRINGARBPROC glGetProgramStringARB;
PFNGLGETVERTEXATTRIBDVARBPROC glGetVertexAttribdvARB;
PFNGLGETVERTEXATTRIBFVARBPROC glGetVertexAttribfvARB;
PFNGLGETVERTEXATTRIBIVARBPROC glGetVertexAttribivARB;
PFNGLGETVERTEXATTRIBPOINTERVARBPROC glGetVertexAttribPointervARB;

PFNGLISPROGRAMARBPROC glIsProgramARB;



//fonction allant rcupr les addresse des fonctions pour l'utilisation de l'arb_vertex_program.
//ARB_Vertex_Program_IsDefined est positionn  true si les extensions sont dfinies.
bool getARBVertexProgramProc()
{
    if (glutExtensionSupported("GL_ARB_vertex_program"))
	{
		glVertexAttrib1sARB = (PFNGLVERTEXATTRIB1SARBPROC) wglGetProcAddress("glVertexAttrib1sARB");
		if (!glVertexAttrib1sARB)
			return false;
		
		glVertexAttrib1fARB = (PFNGLVERTEXATTRIB1FARBPROC) wglGetProcAddress("glVertexAttrib1fARB");
		if (!glVertexAttrib1fARB)
			return false;
		
		glVertexAttrib1dARB = (PFNGLVERTEXATTRIB1DARBPROC) wglGetProcAddress("glVertexAttrib1dARB");
		if (!glVertexAttrib1dARB)
			return false;
		
		glVertexAttrib2sARB = (PFNGLVERTEXATTRIB2SARBPROC) wglGetProcAddress("glVertexAttrib2sARB");
		if (!glVertexAttrib2sARB)
			return false;
		
		glVertexAttrib2fARB = (PFNGLVERTEXATTRIB2FARBPROC) wglGetProcAddress("glVertexAttrib2fARB");
		if (!glVertexAttrib2fARB)
			return false;
		
		glVertexAttrib2dARB = (PFNGLVERTEXATTRIB2DARBPROC) wglGetProcAddress("glVertexAttrib2dARB");
		if (!glVertexAttrib2dARB)
			return false;
		
		glVertexAttrib3sARB = (PFNGLVERTEXATTRIB3SARBPROC) wglGetProcAddress("glVertexAttrib3sARB");
		if (!glVertexAttrib3sARB)
			return false;
		
		glVertexAttrib3fARB = (PFNGLVERTEXATTRIB3FARBPROC) wglGetProcAddress("glVertexAttrib3fARB");
		if (!glVertexAttrib3fARB)
			return false;
		
		glVertexAttrib3dARB = (PFNGLVERTEXATTRIB3DARBPROC) wglGetProcAddress("glVertexAttrib3dARB");
		if (!glVertexAttrib3dARB)
			return false;
		
		glVertexAttrib4sARB = (PFNGLVERTEXATTRIB4SARBPROC) wglGetProcAddress("glVertexAttrib4sARB");
		if (!glVertexAttrib4sARB)
			return false;
		
		glVertexAttrib4fARB = (PFNGLVERTEXATTRIB4FARBPROC) wglGetProcAddress("glVertexAttrib4fARB");
		if (!glVertexAttrib4fARB)
			return false;
		
		glVertexAttrib4dARB = (PFNGLVERTEXATTRIB4DARBPROC) wglGetProcAddress("glVertexAttrib4dARB");
		if (!glVertexAttrib4dARB)
			return false;
		
		glVertexAttrib4NubARB = (PFNGLVERTEXATTRIB4NUBARBPROC) wglGetProcAddress("glVertexAttrib4NubARB");
		if (!glVertexAttrib4NubARB)
			return false;
		
		
		glVertexAttrib1svARB = (PFNGLVERTEXATTRIB1SVARBPROC) wglGetProcAddress("glVertexAttrib1svARB");
		if (!glVertexAttrib1svARB)
			return false;
		
		glVertexAttrib1fvARB = (PFNGLVERTEXATTRIB1FVARBPROC) wglGetProcAddress("glVertexAttrib1fvARB");
		if (!glVertexAttrib1fvARB)
			return false;
		
		glVertexAttrib1dvARB = (PFNGLVERTEXATTRIB1DVARBPROC) wglGetProcAddress("glVertexAttrib1dvARB");
		if (!glVertexAttrib1dvARB)
			return false;
		
		glVertexAttrib2svARB = (PFNGLVERTEXATTRIB2SVARBPROC) wglGetProcAddress("glVertexAttrib2svARB");
		if (!glVertexAttrib2svARB)
			return false;
		
		glVertexAttrib2fvARB = (PFNGLVERTEXATTRIB2FVARBPROC) wglGetProcAddress("glVertexAttrib2fvARB");
		if (!glVertexAttrib2fvARB)
			return false;
		
		glVertexAttrib2dvARB = (PFNGLVERTEXATTRIB2DVARBPROC) wglGetProcAddress("glVertexAttrib2dvARB");
		if (!glVertexAttrib2dvARB)
			return false;
		
		glVertexAttrib3svARB = (PFNGLVERTEXATTRIB3SVARBPROC) wglGetProcAddress("glVertexAttrib3svARB");
		if (!glVertexAttrib3svARB)
			return false;
		
		glVertexAttrib3fvARB = (PFNGLVERTEXATTRIB3FVARBPROC) wglGetProcAddress("glVertexAttrib3fvARB");
		if (!glVertexAttrib3fvARB)
			return false;
		
		glVertexAttrib3dvARB = (PFNGLVERTEXATTRIB3DVARBPROC) wglGetProcAddress("glVertexAttrib3dvARB");
		if (!glVertexAttrib3dvARB)
			return false;
		
		glVertexAttrib4bvARB = (PFNGLVERTEXATTRIB4BVARBPROC) wglGetProcAddress("glVertexAttrib4bvARB");
		if (!glVertexAttrib4bvARB)
			return false;
		
		glVertexAttrib4svARB = (PFNGLVERTEXATTRIB4SVARBPROC) wglGetProcAddress("glVertexAttrib4svARB");
		if (!glVertexAttrib4svARB)
			return false;
		
		glVertexAttrib4ivARB = (PFNGLVERTEXATTRIB4IVARBPROC) wglGetProcAddress("glVertexAttrib4ivARB");
		if (!glVertexAttrib4ivARB)
			return false;
		
		glVertexAttrib4ubvARB = (PFNGLVERTEXATTRIB4UBVARBPROC) wglGetProcAddress("glVertexAttrib4ubvARB");
		if (!glVertexAttrib4ubvARB)
			return false;
		
		glVertexAttrib4usvARB = (PFNGLVERTEXATTRIB4USVARBPROC) wglGetProcAddress("glVertexAttrib4usvARB");
		if (!glVertexAttrib4usvARB)
			return false;
		
		glVertexAttrib4uivARB = (PFNGLVERTEXATTRIB4UIVARBPROC) wglGetProcAddress("glVertexAttrib4uivARB");
		if (!glVertexAttrib4uivARB)
			return false;
		
		glVertexAttrib4fvARB = (PFNGLVERTEXATTRIB4FVARBPROC) wglGetProcAddress("glVertexAttrib4fvARB");
		if (!glVertexAttrib4fvARB)
			return false;
		
		glVertexAttrib4dvARB = (PFNGLVERTEXATTRIB4DVARBPROC) wglGetProcAddress("glVertexAttrib4dvARB");
		if (!glVertexAttrib4dvARB)
			return false;
		
		glVertexAttrib4NbvARB = (PFNGLVERTEXATTRIB4NBVARBPROC) wglGetProcAddress("glVertexAttrib4NbvARB");
		if (!glVertexAttrib4NbvARB)
			return false;
		
		glVertexAttrib4NsvARB = (PFNGLVERTEXATTRIB4NSVARBPROC) wglGetProcAddress("glVertexAttrib4NsvARB");
		if (!glVertexAttrib4NsvARB)
			return false;
		
		glVertexAttrib4NivARB = (PFNGLVERTEXATTRIB4NIVARBPROC) wglGetProcAddress("glVertexAttrib4NivARB");
		if (!glVertexAttrib4NivARB)
			return false;
		
		glVertexAttrib4NubvARB = (PFNGLVERTEXATTRIB4NUBVARBPROC) wglGetProcAddress("glVertexAttrib4NubvARB");
		if (!glVertexAttrib4NubvARB)
			return false;
		
		glVertexAttrib4NusvARB = (PFNGLVERTEXATTRIB4NUSVARBPROC) wglGetProcAddress("glVertexAttrib4NusvARB");
		if (!glVertexAttrib4NusvARB)
			return false;
		
		glVertexAttrib4NuivARB = (PFNGLVERTEXATTRIB4NUIVARBPROC) wglGetProcAddress("glVertexAttrib4NuivARB");
		if (!glVertexAttrib4NuivARB)
			return false;
		
		glVertexAttribPointerARB = (PFNGLVERTEXATTRIBPOINTERARBPROC) wglGetProcAddress("glVertexAttribPointerARB");
		if (!glVertexAttribPointerARB)
			return false;
		
		glEnableVertexAttribArrayARB = (PFNGLENABLEVERTEXATTRIBARRAYARBPROC) wglGetProcAddress("glEnableVertexAttribArrayARB");
		if (!glEnableVertexAttribArrayARB)
			return false;
		
		glDisableVertexAttribArrayARB = (PFNGLDISABLEVERTEXATTRIBARRAYARBPROC) wglGetProcAddress("glDisableVertexAttribArrayARB");
		if (!glDisableVertexAttribArrayARB)
			return false;
		
		glProgramStringARB = (PFNGLPROGRAMSTRINGARBPROC) wglGetProcAddress("glProgramStringARB");
		if (!glProgramStringARB)
			return false;
		
		glBindProgramARB = (PFNGLBINDPROGRAMARBPROC) wglGetProcAddress("glBindProgramARB");
		if (!glBindProgramARB)
			return false;
		
		glDeleteProgramsARB = (PFNGLDELETEPROGRAMSARBPROC) wglGetProcAddress("glDeleteProgramsARB");
		if (!glDeleteProgramsARB)
			return false;
		
		glGenProgramsARB = (PFNGLGENPROGRAMSARBPROC) wglGetProcAddress("glGenProgramsARB");
		if (!glGenProgramsARB)
			return false;
		
		glProgramEnvParameter4dARB = (PFNGLPROGRAMENVPARAMETER4DARBPROC) wglGetProcAddress("glProgramEnvParameter4dARB");
		if (!glProgramEnvParameter4dARB)
			return false;
		
		glProgramEnvParameter4dvARB = (PFNGLPROGRAMENVPARAMETER4DVARBPROC) wglGetProcAddress("glProgramEnvParameter4dvARB");
		if (!glProgramEnvParameter4dvARB)
			return false;
		
		glProgramEnvParameter4fARB = (PFNGLPROGRAMENVPARAMETER4FARBPROC) wglGetProcAddress("glProgramEnvParameter4fARB");
		if (!glProgramEnvParameter4fARB)
			return false;
		
		glProgramEnvParameter4fvARB = (PFNGLPROGRAMENVPARAMETER4FVARBPROC) wglGetProcAddress("glProgramEnvParameter4fvARB");
		if (!glProgramEnvParameter4fvARB)
			return false;
		
		glProgramLocalParameter4dARB = (PFNGLPROGRAMLOCALPARAMETER4DARBPROC) wglGetProcAddress("glProgramLocalParameter4dARB");
		if (!glProgramLocalParameter4dARB)
			return false;
		
		glProgramLocalParameter4dvARB = (PFNGLPROGRAMLOCALPARAMETER4DVARBPROC) wglGetProcAddress("glProgramLocalParameter4dvARB");
		if (!glProgramLocalParameter4dvARB)
			return false;
		
		glProgramLocalParameter4fARB = (PFNGLPROGRAMLOCALPARAMETER4FARBPROC) wglGetProcAddress("glProgramLocalParameter4fARB");
		if (!glProgramLocalParameter4fARB)
			return false;
		
		glProgramLocalParameter4fvARB = (PFNGLPROGRAMLOCALPARAMETER4FVARBPROC) wglGetProcAddress("glProgramLocalParameter4fvARB");
		if (!glProgramLocalParameter4fvARB)
			return false;
		
		glGetProgramEnvParameterdvARB = (PFNGLGETPROGRAMENVPARAMETERDVARBPROC) wglGetProcAddress("glGetProgramEnvParameterdvARB");
		if (!glGetProgramEnvParameterdvARB)
			return false;
		
		glGetProgramEnvParameterfvARB = (PFNGLGETPROGRAMENVPARAMETERFVARBPROC) wglGetProcAddress("glGetProgramEnvParameterfvARB");
		if (!glGetProgramEnvParameterfvARB)
			return false;
		
		glGetProgramLocalParameterdvARB = (PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC) wglGetProcAddress("glGetProgramLocalParameterdvARB");
		if (!glGetProgramLocalParameterdvARB)
			return false;
		
		glGetProgramLocalParameterfvARB = (PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC) wglGetProcAddress("glGetProgramLocalParameterfvARB");
		if (!glGetProgramLocalParameterfvARB)
			return false;
		
		glGetProgramivARB = (PFNGLGETPROGRAMIVARBPROC) wglGetProcAddress("glGetProgramivARB");
		if (!glGetProgramivARB)
			return false;
		
		glGetProgramStringARB = (PFNGLGETPROGRAMSTRINGARBPROC) wglGetProcAddress("glGetProgramStringARB");
		if (!glGetProgramStringARB)
			return false;
		
		glGetVertexAttribdvARB = (PFNGLGETVERTEXATTRIBDVARBPROC) wglGetProcAddress("glGetVertexAttribdvARB");
		if (!glGetVertexAttribdvARB)
			return false;
		
		glGetVertexAttribfvARB = (PFNGLGETVERTEXATTRIBFVARBPROC) wglGetProcAddress("glGetVertexAttribfvARB");
		if (!glGetVertexAttribfvARB)
			return false;
		
		glGetVertexAttribivARB = (PFNGLGETVERTEXATTRIBIVARBPROC) wglGetProcAddress("glGetVertexAttribivARB");
		if (!glGetVertexAttribivARB)
			return false;
		
		glGetVertexAttribPointervARB = (PFNGLGETVERTEXATTRIBPOINTERVARBPROC) wglGetProcAddress("glGetVertexAttribPointervARB");
		if (!glGetVertexAttribPointervARB)
			return false;
		
		glIsProgramARB = (PFNGLISPROGRAMARBPROC) wglGetProcAddress("glIsProgramARB");
		if (!glIsProgramARB)
			return false;

		ARB_Vertex_Program_IsDefined = true;
	}
	
	return ARB_Vertex_Program_IsDefined;
}

//fonction permetant de charger un verte_program arb en "mmoire vido"
// prcondition :
//		- ARB_Vertex_Program_IsDefined doit tre positionner a true.
// paramtres :
//		- vpID, l'addresse de la variable qui recevra l'identifiant  binder du vertex_program.
//		- prgmString, la chaine du vertex_program  compiler.
void loadARBVertexProgram(unsigned int * vpID, const unsigned char * prgmString)
{
	if(ARB_Vertex_Program_IsDefined)				//vrifie que l'extension est support
	{
		glEnable(GL_VERTEX_PROGRAM_ARB);
		glGenProgramsARB(1, vpID);
		glBindProgramARB(GL_VERTEX_PROGRAM_ARB, *vpID);
		//charge le program en mmoire
		glProgramStringARB(GL_VERTEX_PROGRAM_ARB, GL_PROGRAM_FORMAT_ASCII_ARB, strlen((const char *)prgmString), prgmString);
		
		//Rapport d'erreur dans la sortie stderr
		if(GL_INVALID_OPERATION == glGetError() )	//une erreur est dtecte
		{
			//rcupre les informations sur l'erreur survenue
			const unsigned char* errorString;
			GLint errorPos = 0;
			errorString=glGetString(GL_PROGRAM_ERROR_STRING_ARB);
			glGetIntegerv(GL_PROGRAM_ERROR_POSITION_ARB,&errorPos);
			
			fprintf(stderr,"une erreur est survenue a la position : %d\n%s\n", errorPos, errorString);
		}
		else
		{
			fprintf(stderr,"\n*** Pas d'erreur de compilation du ARB_vertex_program ***\n");
		}
		
		glDisable(GL_VERTEX_PROGRAM_ARB);
	}
}

//fonction permetant d'effaer un verte_program arb de la "mmoire vido"
// prcondition :
//		- ARB_Vertex_Program_IsDefined doit tre positionner a true.
// paramtre :
//		- vpID, l'addresse de la variable qui contient l'identifiant du vertex_program  effacer.
void DeleteARBVertexProgram(unsigned int * vpID)
{
	if(ARB_Vertex_Program_IsDefined)				//vrifie que l'extension est support
	{
		glDeleteProgramsARB(1, vpID);
	}
}
