
#ifndef PDL_BASICRENDER
#define PDL_BASICRENDER

#include "AbstractDrawer.h"

#include "Model.h"

#ifdef WIN32
#include <windows.h>
#endif
#include <GL\gl.h>
#include "GL\glut.h"
#include "GL\glext.h"

/**
*	Classe d'affichage d'une classe Model en toonshading  l'cran. Le rendu est pour
*	tout le stype de carte compatible OpenGL 1.2 minimum.
*		==> 2 pass.
*		==> Calcul toonshading avec le CPU.
*
*		La carte doit supporter :
*			- les objet de textures (OpenGL 1.2)
*			- les tableau de coordonne (OpenGL 1.1)
*/
class BasicRender : public AbstractDrawer
{
private:
	/**
	*	Le dernier nombre de coordonne de texture allouer
	* Permet d'viter de redfinir pour chaque dessin le tableau des coord de
	* texture utilis pour le rendu toon allou en mmoire system.
	*/
	unsigned int lastNumberOfToonTexCoord;
	
	/**
	*	Le tableau de coordonne de texture Toon.
	*/
	float *diffuseToonTexCoord;

public:
	/**
	* Constructeur
	*/
	BasicRender();

	/**
	* Destructeur
	*/
	virtual ~BasicRender();

	/**
	* Dessine un model en toon shading avec sa texture diffuse.
	*
	*	prcondition :
	* - aucune option OpenGL pour l'affichage n'a t activ (blending, depth, vertexprogram....)
	*
	* @param model le pointeur sur le model  afficher
	* @param modelPos le vecteur donnant la position de la lumire
	*/
	void draw(Model *model,RULES_Vector modelPos);

	/**
	* Dessine un model en toon shading sans sa texture diffuse.
	*
	*	prcondition :
	* - aucune option OpenGL pour l'affichage n'a t activ (blending, depth, vertexprogram....)
	*
	* @param model le pointeur sur le model  afficher
	* @param modelPos le vecteur donnant la position de la lumire
	* @param silhouette true si on doit dessinn la silhouette
	*/
	void drawToonOnly( Model *model, RULES_Vector modelPos,bool silhouette);
};

#endif