// Bouton.cpp: implementation of the Bouton class.
//
//////////////////////////////////////////////////////////////////////

#include "Bouton.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Bouton::Bouton()
{

}

Bouton::~Bouton()
{
	delete this->imageNormal;
	delete this->imagePassed;
}

bool Bouton::isIn(int mouseX, int mouseY)
{
	return ((mouseX > x) && (mouseX < x+width) 
		 && (mouseY > y) && (mouseY < y+height));
}

int Bouton::getTop()
{
	return y;
}

int Bouton::getLeft()
{
	return x;
}

void Bouton::setTop(int top)
{
	y = top;
}

void Bouton::setLeft(int left)
{
	x = left;
}

void Bouton::draw(int mouseX, int mouseY)
{
	glDisable(GL_DEPTH_TEST);
	// on passe en mode projection
	glMatrixMode(GL_PROJECTION);
		
				// on sauvegarde la matrice de projection
	glPushMatrix();
	
		// on nettoie la matrice de projection
		glLoadIdentity();
		
		// on passe en mode ortho de la taille de l'ecran
		glOrtho(0,1024,768,0,-1,1);	
		
		// on passe en mode modelview
		glMatrixMode(GL_MODELVIEW);
		
		// on sauvegarde la matrice de modelview
		glPushMatrix();
		
			// on nettoie la matrice de projection
			glLoadIdentity();
			
			glEnable(GL_TEXTURE_2D);
			if (this->isIn(mouseX,mouseY))
			{
				// si la souris est dessus le bouton, on selectionne la texture passed
				glBindTexture(GL_TEXTURE_2D, this->imagePassed->getId());
			}
			else
			{
				// la souris n'est pas dessus le bouton, on affiche en mode normal.
				glBindTexture(GL_TEXTURE_2D, this->imageNormal->getId());
			}
			// on affiche le rectangle du bouton
			glBegin(GL_QUADS);
				glTexCoord2f(0,1);
				glVertex2f(x,y);
				glTexCoord2f(1,1);
				glVertex2f(x+width,y);
				glTexCoord2f(1,0);
				glVertex2f(x + width,y + height);
				glTexCoord2f(0,0);
				glVertex2f(x,y + height);
			glEnd();

			glMatrixMode(GL_PROJECTION);
		
		// et on recupere la matrice de projection sauvegard precedement
		glPopMatrix();	
		
		// on selectionne la matrice de projection modelview
		glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	// on desactive le depth test
	glEnable(GL_DEPTH_TEST);

}

void Bouton::setImageNormal(RULES_Texture *text)
{
	this->imageNormal = text;
}

void Bouton::setImagePassed(RULES_Texture *text)
{
	this->imagePassed = text;
}

void Bouton::setPosition(int posX, int posY)
{
	this->x = posX;
	this->y = posY;
}

void Bouton::setHeight(int h)
{
	this->height = h;
}

void Bouton::setWidth(int w)
{
	this->width = w;
}
