
#include "FastRender.h"

#include "ARB_multitexture.h"
#include "ARB_Vertex_Program.h"

// TODO vrifier bon chargement du vertex program


FastRender::FastRender()
{
	this->lightPos = new RULES_Vector();
	this->texSkinID = 0;
	this->texToonDiffuseID = 0;
	vpID=0;

	getARBVertexProgramProc();
	loadARBVertexProgram(&vpID, &VP_TOON_ARB[0]);
}

FastRender::~FastRender()
{
	DeleteARBVertexProgram(&vpID);
}


void FastRender::draw(Model *model,RULES_Vector modelPos)
{
	//***********************
	//*     pr-calcul      *
	//***********************

	// inutile car calcul dans le VP

	//init vertex program
	glEnable(GL_VERTEX_PROGRAM_ARB);
	glBindProgramARB(GL_VERTEX_PROGRAM_ARB,vpID);

	//on positionne la lumire
	//utiliser un pointer v ==> impossible : model pos ne stocke qu'un float[3]
	glProgramEnvParameter4fARB(GL_VERTEX_PROGRAM_ARB,69,modelPos.getX(),modelPos.getY(),modelPos.getZ(),1 );


	//***********************
	//*     rendu Toon      *
	//***********************

	//*** activation des tableaux de coordonne
	glEnableClientState(GL_VERTEX_ARRAY);
	glVertexPointer(3,GL_FLOAT,sizeof(ModelVertex),model->getVertex()->vertex.getCoord());
	
	glEnableClientState(GL_NORMAL_ARRAY);
	glNormalPointer( GL_FLOAT, sizeof(ModelVertex), model->getVertex()->normal.getCoord() );

	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glTexCoordPointer(2,GL_FLOAT,sizeof(ModelVertex),model->getVertex()->texCoord);


	glActiveTextureARB(GL_TEXTURE1_ARB);
	glEnable(GL_TEXTURE_2D);
	glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
	glBindTexture(GL_TEXTURE_2D,model->getTexture()->getId());

	glActiveTextureARB(GL_TEXTURE0_ARB);
	glEnable(GL_TEXTURE_2D);
	glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
	glBindTexture(GL_TEXTURE_2D,this->getTexToonDiffuseID());


	glEnable(GL_CULL_FACE);
	glFrontFace(GL_CCW);
	glCullFace(GL_BACK);										//cull des faces arrire

	//*** affichage model
	glDrawArrays(GL_TRIANGLES,0,model->getVertexNumber());

	//disable normal_array
	glDisableClientState(GL_NORMAL_ARRAY);

	//disable textureCoord_array
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);

	//disable vertex program
	glDisable(GL_VERTEX_PROGRAM_ARB);


	//***********************
	//*   rendu silhouette  *
	//***********************

	//*** prparation affichage
	glFrontFace(GL_CCW);
	glCullFace(GL_FRONT);//cull des faces avant
	glDepthFunc(GL_LESS);
	glPolygonMode(GL_BACK,GL_LINE);
	glPolygonMode(GL_FRONT,GL_LINE);

	glActiveTextureARB(GL_TEXTURE1_ARB);
	glDisable(GL_TEXTURE_2D);
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glDisable(GL_TEXTURE_2D);

	//face arrire en ligne
	glLineWidth(3);

	//*** affichage model
	glColor3f(0,0,0);
	glDrawArrays(GL_TRIANGLES,0,model->getVertexNumber());

	//********** on dsactive tout **********
	//dsactivation des tableaux de coordonne de vertices
	glDisableClientState(GL_VERTEX_ARRAY);
	//dsactivation culling
	glDisable(GL_CULL_FACE);
	glEnable(GL_TEXTURE_2D);
	//face arrire pleine
	glDepthFunc(GL_LEQUAL);
	glPolygonMode(GL_BACK,GL_FILL);
	glPolygonMode(GL_FRONT,GL_FILL);
}

void FastRender::drawToonOnly( Model *model, RULES_Vector modelPos,bool silhouette)
{
	//***********************
	//*     pr-calcul      *
	//***********************

	// inutile car calcul dans le VP

	//init vertex program
	glEnable(GL_VERTEX_PROGRAM_ARB);
	glBindProgramARB(GL_VERTEX_PROGRAM_ARB,vpID);

	//on positionne la lumire
	//utiliser un pointer v ==> impossible : model pos ne stocke qu'un float[3]
	glProgramEnvParameter4fARB(GL_VERTEX_PROGRAM_ARB,69,modelPos.getX(),modelPos.getY(),modelPos.getZ(),1 );


	//***********************
	//*     rendu Toon      *
	//***********************

	//*** activation des tableaux de coordonne
	glEnableClientState(GL_VERTEX_ARRAY);
	glVertexPointer(3,GL_FLOAT,sizeof(ModelVertex),model->getVertex()->vertex.getCoord());
	
	glEnableClientState(GL_NORMAL_ARRAY);
	glNormalPointer( GL_FLOAT, sizeof(ModelVertex), model->getVertex()->normal.getCoord() );


	glActiveTextureARB(GL_TEXTURE0_ARB);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,this->getTexToonDiffuseID());
	glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);


	glEnable(GL_CULL_FACE);
	glCullFace(GL_BACK);										//cull des faces arrire

	//*** affichage model
	glDrawArrays(GL_TRIANGLES,0,model->getVertexNumber());

	//disable normal_array
	glDisableClientState(GL_NORMAL_ARRAY);

	//disable vertex program
	glDisable(GL_VERTEX_PROGRAM_ARB);


	//***********************
	//*   rendu silhouette  *
	//***********************
	if(silhouette)
	{
		//*** prparation affichage
		glCullFace(GL_FRONT);										//cull des faces avant

		glActiveTextureARB(GL_TEXTURE1_ARB);
		glDisable(GL_TEXTURE_2D);
		glActiveTextureARB(GL_TEXTURE0_ARB);
		glDisable(GL_TEXTURE_2D);

		//face arrire en ligne
		glPolygonMode(GL_BACK,GL_LINE);
		glLineWidth(3);

		//*** affichage model
		glColor3f(0,0,0);
		glDrawArrays(GL_TRIANGLES,0,model->getVertexNumber());

		//face arrire pleine
		glPolygonMode(GL_BACK,GL_FILL);
	}

	//********** on dsactive tout **********
	//dsactivation des tableaux de coordonne de vertices
	glDisableClientState(GL_VERTEX_ARRAY);
	//dsactivation culling
	glDisable(GL_CULL_FACE);
	glEnable(GL_TEXTURE_2D);
}

	
void FastRender::setVPID(unsigned int *id)
{
	vpID=*id;
}

