// FirstMenu.cpp: implementation of the FirstMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "FirstMenu.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FirstMenu::FirstMenu()
{
	this->image = new RULES_Texture();
	this->image->loadBMP("./ressources/textures/firstMenu.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,false,0,0,255,0,1);
	firstDrawDone = false;
}

FirstMenu::~FirstMenu()
{
	if (image != NULL)
	{
		delete this->image ;
		image = NULL;
	}
}

void FirstMenu::draw(void)
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	gluLookAt(0,100,100,0,0,0,0,1,0);
	// affiche un rectangle de test
	// on desactive le depth test
	glDisable(GL_DEPTH_TEST);
	// on passe en mode projection
	glMatrixMode(GL_PROJECTION);
		
				// on sauvegarde la matrice de projection
	glPushMatrix();
	
		// on nettoie la matrice de projection
		glLoadIdentity();
		
		// on passe en mode ortho de la taille de l'ecran
		glOrtho(0,1024,0,768,-1,1);	
		
		// on passe en mode modelview
		glMatrixMode(GL_MODELVIEW);
		
		// on sauvegarde la matrice de modelview
		glPushMatrix();
		
			// on nettoie la matrice de projection
			glLoadIdentity();
			
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, this->image->getId());
			glBegin(GL_QUADS);
				glTexCoord2f(0,0);
				glVertex3f(0,0,0);
				glTexCoord2f(1,0);
				glVertex3f(1024,0,0);
				glTexCoord2f(1,1);
				glVertex3f(1024,768,0);
				glTexCoord2f(0,1);
				glVertex3f(0,768,0);
			glEnd();

			glMatrixMode(GL_PROJECTION);
		
		// et on recupere la matrice de projection sauvegard precedement
		glPopMatrix();	
		
		// on selectionne la matrice de projection modelview
		glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	// on desactive le depth test
	glEnable(GL_DEPTH_TEST);

	RULES_Vector pos;
	pos.setCoord(mouseX,768-mouseY,0);
	ParticleEngine::getInstance()->frame(&pos);
	if (firstDrawDone)
	{
		Mouse::getInstance()->draw(&pos);
	}

	glFlush();
	firstDrawDone = true;
	glutSwapBuffers();
	// on lui fait charger la partie

}


void FirstMenu::idle(void)
{
	static bool first = true;
	if ((first)&&(firstDrawDone))
	{
		// on charge la partie
		Game::getGame()->setCurrentGlut(this->currentGlut);
		// on charge le menu principal
		MainMenu::getInstance()->setCurrentGlut(this->currentGlut);
		// on charge le dernier menu
		LastMenu::getInstance()->setCurrentGlut(this->currentGlut);
		first = false;
	}
	// on charge le sound manager et on verifie le son
	SoundManager::getInstance()->checkSound();
	glutPostRedisplay();

}


void FirstMenu::mouseClicked(int boutton,int etat,int x,int y)
{
	if (etat == GLUT_DOWN)
	{
		SoundManager::getInstance()->playClic();
	}
	GLUT * main = MainMenu::getInstance();
	*(this->currentGlut) = main; 
	main->setCurrentGlut(this->currentGlut);
}

void FirstMenu::mouseMoved(int x,int y)
{
	mouseX = x;
	mouseY = y;
}

void FirstMenu::mouseMovedClicked(int x,int y)
{

}


void FirstMenu::keyPressed(unsigned char key,int x,int y)
{
	GLUT * main = MainMenu::getInstance();
	*(this->currentGlut) = main; 
	main->setCurrentGlut(this->currentGlut);
}

void FirstMenu::keyReleased(unsigned char key,int x,int y)
{

}


void FirstMenu::reshape(int largeur,int hauteur)
{
	glViewport(0,0,(GLsizei) largeur,(GLsizei) hauteur);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90,largeur/hauteur,1,10000);
	glMatrixMode(GL_MODELVIEW);

}

