// Glow.cpp: implementation of the Glow class.
//
//////////////////////////////////////////////////////////////////////

#include "Glow.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Glow::Glow(unsigned int width,unsigned int height)
{
	glow_width=width;
	glow_height=height;

	glow_nbPass=0;

	glow_power=1;

	//cration de la texture
	float *emptyBuffer=new float[glow_width * glow_height * 3];	//buffer vide
	glEnable(GL_TEXTURE_2D);
	glGenTextures( 1, &idTex );
	glBindTexture(GL_TEXTURE_2D, idTex);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,(GLsizei)glow_width,(GLsizei)glow_height,0,GL_RGB,GL_FLOAT,emptyBuffer);
	glDisable(GL_TEXTURE_2D);
	delete emptyBuffer;
}

Glow::~Glow()
{

}

void Glow::loadPixelIntoTexture()
{
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,idTex);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

	//copy la zone de back buffer voulut dans la texture
	glReadBuffer(GL_BACK);
	glCopyTexSubImage2D(GL_TEXTURE_2D,0,0,0,0,0,(GLsizei)glow_width,(GLsizei)glow_height);

	glDisable(GL_TEXTURE_2D);
}

void Glow::initGlowDrawing()
{
	glGetIntegerv(GL_VIEWPORT, tmpViewPort);
	glViewport(0, 0, (GLsizei) glow_width, (GLsizei) glow_height);
}

void Glow::finishGlowDrawing()
{
	glViewport(tmpViewPort[0], tmpViewPort[1], tmpViewPort[2], tmpViewPort[3]);
}

void Glow::computeGlow()
{
 	int i;

	glDisable(GL_DEPTH_TEST);
	glDepthMask(GL_FALSE);

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0,glow_width,0,glow_height);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE,GL_ONE);

	this->loadPixelIntoTexture();


	// Algorithme de blur de la texture de glow pour OpenGL standard
	// L'algorithme opre un dcalage sur les texels en largeur puis en hauteur.
	for(i=0; i<(int)glow_nbPass; i++)
	{
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, idTex);
		glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );

		glClear(GL_COLOR_BUFFER_BIT);
		glBegin(GL_QUADS);

		glColor3f( 0.4, 0.4, 0.4);//////////
		glTexCoord2f(0,0);
		glVertex2f(0, 0);
		glTexCoord2f(1,0);
		glVertex2f(glow_width, 0);
		glTexCoord2f(1,1);
		glVertex2f(glow_width, glow_height);
		glTexCoord2f(0,1);
		glVertex2f(0, glow_height);
		glColor3f( 0.2, 0.2, 0.2);//////////
		glTexCoord2f(0,0);
		glVertex2f(0+1, 0);
		glTexCoord2f(1,0);
		glVertex2f(glow_width+1, 0);
		glTexCoord2f(1,1);
		glVertex2f(glow_width+1, glow_height);
		glTexCoord2f(0,1);
		glVertex2f(0+1, glow_height);
		glColor3f( 0.2, 0.2, 0.2);//////////
		glTexCoord2f(0,0);
		glVertex2f(0-1, 0);
		glTexCoord2f(1,0);
		glVertex2f(glow_width-1, 0);
		glTexCoord2f(1,1);
		glVertex2f(glow_width-1, glow_height);
		glTexCoord2f(0,1);
		glVertex2f(0-1, glow_height);
		glColor3f( 0.1, 0.1, 0.1);//////////
		glTexCoord2f(0,0);
		glVertex2f(0+2, 0);
		glTexCoord2f(1,0);
		glVertex2f(glow_width+2, 0);
		glTexCoord2f(1,1);
		glVertex2f(glow_width+2, glow_height);
		glTexCoord2f(0,1);
		glVertex2f(0+2, glow_height);
		glColor3f( 0.1, 0.1, 0.1);//////////
		glTexCoord2f(0,0);
		glVertex2f(0-2, 0);
		glTexCoord2f(1,0);
		glVertex2f(glow_width-2, 0);
		glTexCoord2f(1,1);
		glVertex2f(glow_width-2, glow_height);
		glTexCoord2f(0,1);
		glVertex2f(0-2, glow_height);
		

		glEnd();
		glDisable(GL_TEXTURE_2D);
		loadPixelIntoTexture();

		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, idTex);
		glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
		glClear(GL_COLOR_BUFFER_BIT);
		glBegin(GL_QUADS);


		glColor3f( 0.4, 0.4, 0.4);//////////
		glTexCoord2f(0,0);
		glVertex2f(0, 0);
		glTexCoord2f(1,0);
		glVertex2f(glow_width, 0);
		glTexCoord2f(1,1);
		glVertex2f(glow_width, glow_height);
		glTexCoord2f(0,1);
		glVertex2f(0, glow_height);
		glColor3f( 0.2, 0.2, 0.2);//////////
		glTexCoord2f(0,0);
		glVertex2f(0, 0+1);
		glTexCoord2f(1,0);
		glVertex2f(glow_width, 0+1);
		glTexCoord2f(1,1);
		glVertex2f(glow_width, glow_height+1);
		glTexCoord2f(0,1);
		glVertex2f(0, glow_height+1);
		glColor3f( 0.2, 0.2, 0.2);//////////
		glTexCoord2f(0,0);
		glVertex2f(0, 0-1);
		glTexCoord2f(1,0);
		glVertex2f(glow_width, 0-1);
		glTexCoord2f(1,1);
		glVertex2f(glow_width, glow_height-1);
		glTexCoord2f(0,1);
		glVertex2f(0, glow_height-1);
		glColor3f( 0.1, 0.1, 0.1);//////////
		glTexCoord2f(0,0);
		glVertex2f(0, 0+2);
		glTexCoord2f(1,0);
		glVertex2f(glow_width, 0+2);
		glTexCoord2f(1,1);
		glVertex2f(glow_width, glow_height+2);
		glTexCoord2f(0,1);
		glVertex2f(0, glow_height+2);
		glColor3f( 0.1, 0.1, 0.1);//////////
		glTexCoord2f(0,0);
		glVertex2f(0, 0-2);
		glTexCoord2f(1,0);
		glVertex2f(glow_width, 0-2);
		glTexCoord2f(1,1);
		glVertex2f(glow_width, glow_height-2);
		glTexCoord2f(0,1);
		glVertex2f(0, glow_height-2);

		glEnd();
		glDisable(GL_TEXTURE_2D);
		loadPixelIntoTexture();
	}

	glDisable(GL_BLEND);

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();

	glEnable(GL_DEPTH_TEST);
	glDepthMask(GL_TRUE);

}

void Glow::renderGlow()
{
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0,1,0,1);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	glDisable(GL_DEPTH_TEST);

	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE,GL_ONE);	//on additione simplement la texture  la scne

	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, idTex);
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );

	//la force est simplement la modulation de la texture de glow
	glColor3f(glow_power,glow_power,glow_power);
	glBegin(GL_QUADS);
	glTexCoord2f(0,0);
	glVertex2f(0,0);
	glTexCoord2f(1,0);
	glVertex2f(1,0);
	glTexCoord2f(1,1);
	glVertex2f(1,1);
	glTexCoord2f(0,1);
	glVertex2f(0,1);
	glEnd();

	glDisable(GL_TEXTURE_2D);

	glEnable(GL_DEPTH_TEST);
	
	glDisable(GL_BLEND);
	
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();

}

void Glow::setWidth(unsigned int width)
{
	glow_width=width;
}

void Glow::setHeight(unsigned int height)
{
	glow_height=height;
}

void Glow::setNbPass(unsigned int nbp)
{
	glow_nbPass=nbp;
}

unsigned int Glow::getNbPass()
{
	return glow_nbPass;
}

unsigned int Glow::getHeight()
{
	return glow_height;
}

unsigned int Glow::getWidth()
{
	return glow_width;
}

float Glow::getGlowPower()
{
	return glow_power;
}

void Glow::setGlowPower(float bp)
{
	glow_power = bp;
}
