// Immeuble.h: interface for the Immeuble class.
//
//////////////////////////////////////////////////////////////////////

/**
 * documentation ralis par Michel de VERDELHAN : michel.deverdelhan@free.fr
 * le 20/10/2004
 */

#if !defined(IMMEUBLE_H)
#define IMMEUBLE_H

#include "Objet.h"

/**
 * classe representant l'immeuble dans le jeu.
 * 
 */
class Immeuble : public Objet  
{
private:
	/**
	 * la position de la lumiere qui tourne autour de l'immeuble, c'est cette position qui est envoy au 
	 * renderer pour l'affichage et la gestion du toon shading
	 */
	RULES_Vector * light;

	/**
	 * la vie restante de l'immeuble. C'est en fait la vie qui est represent comme la vie restante dans le jeu.
	 * a l'origine, l'immeuble devait s'enfoncer dans le sol au fur et a mesure qu'il perdait de la vie mais cela n'a
	 * finalement pas t implement.
	 */
	int vie;

public:

	/**
	 * defini la vie de l'immeuble
	 * @param life: la vie de l'immeuble
	 */
	void setVie(int life);

	/**
	 * retourne la vie de l'immeuble
	 * @return int: la vie de l'immeuble
	 */
	int getVie();

	/**
	 * definit la position de la lumiere qui eclaire l'immeuble
	 * @param light: lo position de la lumiere
	 */
	void setLight(RULES_Vector * light);

	/**
	 * determide si l'immeuble est encore en vie.
	 *@ return true: l'immeuble est vivant
	 */
	bool isAlive();

	/**
	 * methode dessinant l'immeuble
	 */
	void draw();

	/**
	 * constructeur par defaut
	 */
	Immeuble();

	/**
	 * destructeur par defaut
	 */
	virtual ~Immeuble();

};

#endif 
