// LastMenu.cpp: implementation of the LastMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "LastMenu.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

LastMenu::LastMenu()
{
	this->image = new RULES_Texture();
	exiting = false;
}

LastMenu::~LastMenu()
{

	if (image != NULL)
	{
		delete this->image ;
		image = NULL;
	}
}

void LastMenu::draw(void)
{
	if (!exiting)
	{
		static bool first = true;
		if (first)
		{
			this->image->loadBMP("./ressources/textures/lastMenu.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,false,0,0,255,0,1);
			first = false;
		}
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();
		gluLookAt(0,100,100,0,0,0,0,1,0);
		// affiche un rectangle de test
		// on desactive le depth test
		glDisable(GL_DEPTH_TEST);
		// on passe en mode projection
		glMatrixMode(GL_PROJECTION);
			
					// on sauvegarde la matrice de projection
		glPushMatrix();
		
			// on nettoie la matrice de projection
			glLoadIdentity();
			
			// on passe en mode ortho de la taille de l'ecran
			glOrtho(0,1024,0,768,-1,1);	
			
			// on passe en mode modelview
			glMatrixMode(GL_MODELVIEW);
			
			// on sauvegarde la matrice de modelview
			glPushMatrix();
			
				// on nettoie la matrice de projection
				glLoadIdentity();
				
				glEnable(GL_TEXTURE_2D);
				glBindTexture(GL_TEXTURE_2D, this->image->getId());
				glBegin(GL_QUADS);
					glTexCoord2f(0,0);
					glVertex3f(0,0,0);
					glTexCoord2f(1,0);
					glVertex3f(1024,0,0);
					glTexCoord2f(1,1);
					glVertex3f(1024,768,0);
					glTexCoord2f(0,1);
					glVertex3f(0,768,0);
				glEnd();

				glMatrixMode(GL_PROJECTION);
			
			// et on recupere la matrice de projection sauvegard precedement
			glPopMatrix();	
			
			// on selectionne la matrice de projection modelview
			glMatrixMode(GL_MODELVIEW);
		glPopMatrix();
		// on desactive le depth test
		glEnable(GL_DEPTH_TEST);

		RULES_Vector pos;
		pos.setCoord(mouseX,768-mouseY,0);
		ParticleEngine::getInstance()->frame(&pos);
		Mouse::getInstance()->draw(&pos);


		glFlush();
		glutSwapBuffers();
	}

}


void LastMenu::idle(void)
{
	glutPostRedisplay();

}


void LastMenu::mouseClicked(int boutton,int etat,int x,int y)
{
	exiting = true;
	exit(1);
}

void LastMenu::mouseMoved(int x,int y)
{
	mouseX = x;
	mouseY = y;


}

void LastMenu::mouseMovedClicked(int x,int y)
{

}


void LastMenu::keyPressed(unsigned char key,int x,int y)
{
	exiting = true;
	exit(1);
}

void LastMenu::keyReleased(unsigned char key,int x,int y)
{

}


void LastMenu::reshape(int largeur,int hauteur)
{
	glViewport(0,0,(GLsizei) largeur,(GLsizei) hauteur);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90,largeur/hauteur,1,10000);
	glMatrixMode(GL_MODELVIEW);

}

