// MainMenu.h: interface for the MainMenu class.
//
//////////////////////////////////////////////////////////////////////

#ifndef MAINMENU_H
#define MAINMENU_H

#include "Menu.h"
#include <GL/glut.h>
#include "Font.h"
#include "Game.h"
#include "ParticleEngine.h"
#include "Menu.h"
#include "SoundManager.h"
#include "Bouton.h"
#include "LastMenu.h"
#include "OptionMenu.h"

class MainMenu : public Menu  
{
private:
	Bouton * resume;
	Bouton * options;
	Bouton * quitter;
	float infoDefile;
	Model * titre;
	RULES_Vector * light;
	Loutre * loutre;
	Font * font;
	RULES_Texture * texFont;
	int mouseX,mouseY;
	Bouton * boutons;
	MainMenu();
public:
	Font * getFont();
	virtual ~MainMenu();
	void draw(void);

	void idle(void);

	void mouseClicked(int boutton,int etat,int x,int y);
	void mouseMoved(int x,int y);
	void mouseMovedClicked(int x,int y);

	void keyPressed(unsigned char key,int x,int y);
	void keyReleased(unsigned char key,int x,int y);
	void specialKeyFunc(int key,int x,int y){};
	void specialKeyUpFunc(int key,int x,int y){};

	void reshape(int largeur,int hauteur);
	static MainMenu * getInstance(){static MainMenu instance;return &instance;};

};

#endif 