// ModelDrawer.h: interface for the ModelDrawer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(MODELDRAWER_H)
#define MODELDRAWER_H

#ifdef WIN32
#include <windows.h>
#endif
#include <GL\gl.h>
#include "Model.h"
#include "RULES_Texture.h"

/**
* Classe virtuel permettant de rendre un model en toon shading suivant diffrente implmentation
*/
class ModelDrawer  
{
public:
	/**
	* Dessinne simplement un model(flat)
	*
	* @param model le pointeur sur le model  afficher
	*/
	void drawSimple(Model *model);

	/**
	* Dessine un model en toon shading avec sa texture diffuse.
	*
	* @param model le pointeur sur le model  afficher
	* @param modelPos le vecteur donnant la position de la lumire
	*/
	virtual void draw( Model *model, RULES_Vector modelPos);

	/**
	* Dessine un model en toon shading sans sa texture diffuse.
	*
	* @param model le pointeur sur le model  afficher
	* @param modelPos le vecteur donnant la position de la lumire
	* @param silhouette true si on doit dessinn la silhouette
	*/
	virtual void drawToonOnly( Model *model, RULES_Vector modelPos,bool silhouette);

	/**
	* Constructeur
	*/
	ModelDrawer();
	/**
	* Destructeur
	*/
	virtual ~ModelDrawer();

};

#endif // !defined(AFX_MODELDRAWER_H__17BCB995_E6D5_4185_BCDD_5E81B504AA5F__INCLUDED_)
