// Mouse.h: interface for the Mouse class.
//
//////////////////////////////////////////////////////////////////////

#ifndef MOUSE_H
#define MOUSE_H

#include "RULES_Texture.h"
#include "RULES_Vector.h"

/**
 * classe gerant l'affichage du curseur de la souris a l'ecran.
 */
class Mouse  
{
private:
	/**
	 * l'image du curseur de la souris
	 */
	RULES_Texture * image;

	/**
	 * le constructeur de la classe, mis en priv pour la pattern singleton
	 */ 
	Mouse();
public:
	/**
	 * destructeur de la classe
	 */
	virtual ~Mouse();

	/**
	 * methode utilise pour afficher le curseur de la souris
	 * @param pos: la position de la souris a l'ecran (en pixels)
	 */
	void draw(RULES_Vector * pos);

	/**
	 * methode retournant l'instance unique de Mouse
	 */
	inline static Mouse * getInstance(){static Mouse instance;return &instance;};

};

#endif
