
#include "RULES_Vector.h"

#include <math.h>

RULES_Vector::RULES_Vector()
{
	coord[0]=0;
	coord[1]=0;
	coord[2]=0;
}


RULES_Vector::~RULES_Vector()
{
}

float* RULES_Vector::getCoord()
{
	return &coord[0];
}

float RULES_Vector::getCoord(int composante)
{
	return coord[composante];
}

float RULES_Vector::getX()
{
	return coord[0];
}

float RULES_Vector::getY()
{
	return coord[1];
}

float RULES_Vector::getZ()
{
	return coord[2];
}


//_ c : pointeur sur 3 float contenant les nouvelles coordonnes.
void RULES_Vector::setCoord(const float *c)
{
	coord[0]=c[0];
	coord[1]=c[1];
	coord[2]=c[2];
}

void RULES_Vector::setCoord(float x,float y,float z)
{
	coord[0]=x;
	coord[1]=y;
	coord[2]=z;
}

void RULES_Vector::setOneCoord(unsigned int xyz, float val)
{
	coord[xyz]=val;
}

RULES_Vector& RULES_Vector::operator =(const RULES_Vector& v)
{
	coord[0]=v.coord[0];
	coord[1]=v.coord[1];
	coord[2]=v.coord[2];

	return *this;
}

RULES_Vector RULES_Vector::operator +(float n)
{
	RULES_Vector tmp;
	tmp.coord[0]=coord[0]+n;
	tmp.coord[1]=coord[1]+n;
	tmp.coord[2]=coord[2]+n;

	return tmp;
}

RULES_Vector RULES_Vector::operator -(float n)
{
	RULES_Vector tmp;
	tmp.coord[0]=coord[0]-n;
	tmp.coord[1]=coord[1]-n;
	tmp.coord[2]=coord[2]-n;

	return tmp;
}

RULES_Vector RULES_Vector::operator *(float n)
{
	RULES_Vector tmp;
	tmp.coord[0]=coord[0]*n;
	tmp.coord[1]=coord[1]*n;
	tmp.coord[2]=coord[2]*n;

	return tmp;
}

RULES_Vector RULES_Vector::operator /(float n)
{
	RULES_Vector tmp;
	tmp.coord[0]=coord[0]/n;
	tmp.coord[1]=coord[1]/n;
	tmp.coord[2]=coord[2]/n;

	return tmp;
}

RULES_Vector RULES_Vector::operator +=(float n)
{
	coord[0]+=n;
	coord[1]+=n;
	coord[2]+=n;

	return *this;
}

RULES_Vector RULES_Vector::operator -=(float n)
{
	coord[0]-=n;
	coord[1]-=n;
	coord[2]-=n;

	return *this;
}

RULES_Vector RULES_Vector::operator *=(float n)
{
	coord[0]*=n;
	coord[1]*=n;
	coord[2]*=n;

	return *this;
}

RULES_Vector RULES_Vector::operator /=(float n)
{
	coord[0]/=n;
	coord[1]/=n;
	coord[2]/=n;

	return *this;
}

RULES_Vector& RULES_Vector::operator +=(const RULES_Vector& v)
{
	coord[0]+=v.coord[0];
	coord[1]+=v.coord[1];
	coord[2]+=v.coord[2];

	return *this;
}

RULES_Vector& RULES_Vector::operator -=(const RULES_Vector& v)
{
	coord[0]-=v.coord[0];
	coord[1]-=v.coord[1];
	coord[2]-=v.coord[2];

	return *this;
}

RULES_Vector& RULES_Vector::operator *=(const RULES_Vector& v)
{
	coord[0]*=v.coord[0];
	coord[1]*=v.coord[1];
	coord[2]*=v.coord[2];

	return *this;
}

RULES_Vector& RULES_Vector::operator /=(const RULES_Vector& v)
{
	coord[0]/=v.coord[0];
	coord[1]/=v.coord[1];
	coord[2]/=v.coord[2];

	return *this;
}

RULES_Vector RULES_Vector::operator +(const RULES_Vector& v)
{
	RULES_Vector tmp;
	tmp.coord[0]=coord[0]+v.coord[0];
	tmp.coord[1]=coord[1]+v.coord[1];
	tmp.coord[2]=coord[2]+v.coord[2];

	return tmp;
}

RULES_Vector RULES_Vector::operator -(const RULES_Vector& v)
{
	RULES_Vector tmp;
	tmp.coord[0]=coord[0]-v.coord[0];
	tmp.coord[1]=coord[1]-v.coord[1];
	tmp.coord[2]=coord[2]-v.coord[2];

	return tmp;
}

RULES_Vector RULES_Vector::operator *(const RULES_Vector& v)
{
	RULES_Vector tmp;
	tmp.coord[0]=coord[0]*v.coord[0];
	tmp.coord[1]=coord[1]*v.coord[1];
	tmp.coord[2]=coord[2]*v.coord[2];

	return tmp;
}

RULES_Vector RULES_Vector::operator /(const RULES_Vector& v)
{
	RULES_Vector tmp;
	tmp.coord[0]=coord[0]/v.coord[0];
	tmp.coord[1]=coord[1]/v.coord[1];
	tmp.coord[2]=coord[2]/v.coord[2];

	return tmp;
}

float RULES_Vector::length()
{
	return (float) sqrt( pow(coord[0],2) + pow(coord[1],2) + pow(coord[2],2) );
}

void RULES_Vector::normalisation()
{
	float l=length();
	coord[0]/=l;
	coord[1]/=l;
	coord[2]/=l;
}

float RULES_Vector::dot3(RULES_Vector *v)
{
	float *coord2=v->getCoord();
	return ( coord[0]*coord2[0] + coord[1]*coord2[1] + coord[2]*coord2[2] );
}

void RULES_Vector::translate(float *t)
{
	coord[0]+=t[0];
	coord[1]+=t[1];
	coord[2]+=t[2];
}

void RULES_Vector::rotate(float rad, bool x, bool y, bool z)
{
	RULES_Vector vTMP=*this;
	float *coord2=vTMP.getCoord();
	if(x)
	{
	coord[1]=coord2[1]*cos(rad)-coord2[2]*sin(rad);
	coord[2]=coord2[1]*sin(rad)+coord2[2]*cos(rad);
	}
	else if(y)
	{
	coord[2]=coord2[2]*cos(rad)-coord2[0]*sin(rad);
	coord[0]=coord2[2]*sin(rad)+coord2[0]*cos(rad);
	}
	else if(z)
	{
	coord[0]=coord2[0]*cos(rad)-coord2[1]*sin(rad);
	coord[1]=coord2[0]*sin(rad)+coord2[1]*cos(rad);
	}
}

void RULES_Vector::prodVectoriel(RULES_Vector *v,RULES_Vector *dir)
{
	float *coord2=v->getCoord();

	dir->setOneCoord(0, coord[1]*coord2[2] - coord[2]*coord2[1] );
	dir->setOneCoord(1, coord[2]*coord2[0] - coord[0]*coord2[2] );
	dir->setOneCoord(2, coord[0]*coord2[1] - coord[1]*coord2[0] );
}
