// VideoMenu.h: interface for the VideoMenu class.
//
//////////////////////////////////////////////////////////////////////

#ifndef VIDEOMENU_H
#define VIDEOMENU_H

#include "Menu.h"
#include "OptionMenu.h"
#include "Game.h"
#include "ParticleEngine.h"
#include "Mouse.h"
#include "Bouton.h"

/**
 * classe gerant le menu des parametres audio.
 *
 * pour plus de renseignement sur les methode de cette classe, voir la classe GLUT
 */
class VideoMenu : public Menu  
{
	int mouseX,mouseY;
	Bouton * retour;
	Bouton * loutreLowCheck;
	Bouton * texQualityUp;
	Bouton * texQualityDown;
	Bouton * glowQualityUp;
	Bouton * glowQualityDown;
	Bouton * filtrageQualityUp;
	Bouton * filtrageQualityDown;

	bool loutreLow;			// est ce qu'on utilise les loutre low
	int texQuality;			// qualit des textures
	int glowQuality;		// qualit du glow
	int filtrageQuality;	// qualite du filtrage des textures

	bool settingHasChange;	//indique si le joueur a chang un paramtre

	VideoMenu();
public:
	virtual ~VideoMenu();
	static VideoMenu * getInstance(){static VideoMenu instance; return &instance;};

	void draw(void);

	void idle(void);

	void mouseClicked(int boutton,int etat,int x,int y);
	void mouseMoved(int x,int y);
	void mouseMovedClicked(int x,int y);

	void keyPressed(unsigned char key,int x,int y);
	void keyReleased(unsigned char key,int x,int y);
	void specialKeyFunc(int key,int x,int y){};
	void specialKeyUpFunc(int key,int x,int y){};

	void reshape(int largeur,int hauteur);

};

#endif